Hex Artifact Content

Artifact 595f0f52581dd537ea64be4835eb232dd318fc1b:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 31 30 22  TCLVERS="8.6.10"
0110: 0a 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20  .if echo "$1" | 
0120: 67 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39  grep '^[0-9][0-9
0130: 5d 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  ]*\.' >/dev/null
0140: 20 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20   || echo "$1" | 
0150: 65 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73  egrep '^(cvs|fos
0160: 73 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c  sil)_' >/dev/nul
0170: 6c 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53  l; then..TCLVERS
0180: 3d 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69  ="$1"...shift.fi
0190: 0a 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a  .export TCLVERS.
01a0: 0a 23 20 41 64 64 20 74 68 65 20 68 65 6c 70 65  .# Add the helpe
01b0: 72 73 20 64 69 72 65 63 74 6f 72 79 20 74 6f 20  rs directory to 
01c0: 74 68 65 20 70 61 74 68 0a 50 41 54 48 3d 22 24  the path.PATH="$
01d0: 28 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22  (cd "$(dirname "
01e0: 24 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22  $(which "$0")")"
01f0: 20 26 26 20 70 77 64 29 22 2f 63 6f 6d 6d 6f 6e   && pwd)"/common
0200: 2f 68 65 6c 70 65 72 73 3a 22 24 7b 50 41 54 48  /helpers:"${PATH
0210: 7d 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a  }".export PATH..
0220: 23 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70  # Verify that "p
0230: 72 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20  re.sh" has been 
0240: 72 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61  run if this is a
0250: 20 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61   development sna
0260: 70 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72  pshot of.# KitCr
0270: 65 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62  eator.if [ -f 'b
0280: 75 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20  uild/pre.sh' ]; 
0290: 74 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20  then..if ! find 
02a0: 27 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f  'kitsh/buildsrc/
02b0: 27 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72  ' -name configur
02c0: 65 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76  e -type f 2>/dev
02d0: 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e  /null | grep con
02e0: 66 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c  figure >/dev/nul
02f0: 6c 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22  l; then...echo "
0300: 50 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20  Please remember 
0310: 74 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72  to run 'build/pr
0320: 65 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70  e.sh' if you exp
0330: 65 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74  ect this build t
0340: 6f 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69  o work." >&2..fi
0350: 0a 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68  .fi..# Define th
0360: 65 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61  e list of all pa
0370: 63 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61  ckages, for clea
0380: 6e 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49  ning purposes.KI
0390: 54 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53  TCREATOR_ALLPKGS
03a0: 3d 22 24 28 0a 09 66 6f 72 20 62 75 69 6c 64 53  ="$(..for buildS
03b0: 63 72 69 70 74 20 69 6e 20 2a 2f 62 75 69 6c 64  cript in */build
03c0: 2e 73 68 3b 20 64 6f 0a 09 09 69 66 20 5b 20 21  .sh; do...if [ !
03d0: 20 2d 78 20 22 24 7b 62 75 69 6c 64 53 63 72 69   -x "${buildScri
03e0: 70 74 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  pt}" ]; then....
03f0: 63 6f 6e 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09  continue...fi...
0400: 09 65 63 68 6f 20 22 24 7b 62 75 69 6c 64 53 63  .echo "${buildSc
0410: 72 69 70 74 7d 22 20 7c 20 73 65 64 20 27 73 40  ript}" | sed 's@
0420: 2f 2e 2a 24 40 40 27 0a 09 64 6f 6e 65 20 7c 20  /.*$@@'..done | 
0430: 74 72 20 24 27 5c 6e 27 20 27 20 27 0a 29 22 0a  tr $'\n' ' '.)".
0440: 0a 23 20 41 6c 77 61 79 73 20 72 65 62 75 69 6c  .# Always rebuil
0450: 64 20 6b 69 74 73 68 0a 72 6d 20 2d 66 20 22 6b  d kitsh.rm -f "k
0460: 69 74 73 68 2f 2e 73 75 63 63 65 73 73 22 0a 66  itsh/.success".f
0470: 6f 72 20 70 6b 67 20 69 6e 20 24 7b 4b 49 54 43  or pkg in ${KITC
0480: 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53 7d 20  REATOR_ALLPKGS} 
0490: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
04a0: 53 7d 3b 20 64 6f 0a 09 69 66 20 5b 20 22 24 7b  S}; do..if [ "${
04b0: 6d 6f 64 65 7d 22 20 21 3d 20 22 72 65 74 72 79  mode}" != "retry
04c0: 22 20 2d 6f 20 21 20 2d 66 20 22 24 7b 70 6b 67  " -o ! -f "${pkg
04d0: 7d 2f 2e 73 75 63 63 65 73 73 22 20 5d 3b 20 74  }/.success" ]; t
04e0: 68 65 6e 0a 09 09 72 6d 20 2d 66 20 22 24 7b 70  hen...rm -f "${p
04f0: 6b 67 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22 20 22  kg}/build.log" "
0500: 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22  ${pkg}/.success"
0510: 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 70 6b 67  ...rm -rf "${pkg
0520: 7d 2f 6f 75 74 22 20 22 24 7b 70 6b 67 7d 2f 69  }/out" "${pkg}/i
0530: 6e 73 74 22 20 22 24 7b 70 6b 67 7d 2f 62 75 69  nst" "${pkg}/bui
0540: 6c 64 22 0a 0a 09 09 72 6d 20 2d 72 66 20 22 24  ld"....rm -rf "$
0550: 7b 70 6b 67 7d 2f 73 72 63 22 2f 74 6d 70 2d 2a  {pkg}/src"/tmp-*
0560: 0a 09 66 69 0a 0a 09 69 66 20 5b 20 22 24 7b 6d  ..fi...if [ "${m
0570: 6f 64 65 7d 22 20 3d 20 22 64 69 73 74 63 6c 65  ode}" = "distcle
0580: 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 09 72 6d  an" ]; then...rm
0590: 20 2d 72 66 20 22 24 7b 70 6b 67 7d 2f 73 72 63   -rf "${pkg}/src
05a0: 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 23 20 57 65  "..fi.done..# We
05b0: 27 72 65 20 61 6c 6c 20 64 6f 6e 65 20 69 66 20  're all done if 
05c0: 77 65 27 72 65 20 69 6e 20 63 6c 65 61 6e 20 6f  we're in clean o
05d0: 72 20 64 69 73 74 63 6c 65 61 6e 20 6d 6f 64 65  r distclean mode
05e0: 0a 69 66 20 5b 20 22 24 7b 6d 6f 64 65 7d 22 20  .if [ "${mode}" 
05f0: 3d 20 22 63 6c 65 61 6e 22 20 2d 6f 20 22 24 7b  = "clean" -o "${
0600: 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73 74 63 6c  mode}" = "distcl
0610: 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 72 6d  ean" ]; then..rm
0620: 20 2d 66 20 74 63 6c 6b 69 74 2d 2a 0a 09 72 6d   -f tclkit-*..rm
0630: 20 2d 66 20 6c 69 62 74 63 6c 6b 69 74 2a 2e 2a   -f libtclkit*.*
0640: 0a 0a 09 65 78 69 74 20 30 0a 66 69 0a 0a 23 20  ...exit 0.fi..# 
0650: 41 64 64 20 70 61 63 6b 61 67 65 73 20 69 6d 70  Add packages imp
0660: 6c 69 65 64 20 62 79 20 74 68 65 20 61 64 64 69  lied by the addi
0670: 74 69 6f 6e 61 6c 20 61 72 67 75 6d 65 6e 74 73  tional arguments
0680: 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 4b 49 54 43  .if [ -z "${KITC
0690: 52 45 41 54 4f 52 5f 50 4b 47 53 7d 22 20 5d 3b  REATOR_PKGS}" ];
06a0: 20 74 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f   then..KITCREATO
06b0: 52 5f 50 4b 47 53 3d 22 74 6b 20 69 74 63 6c 20  R_PKGS="tk itcl 
06c0: 6d 6b 34 74 63 6c 22 0a 66 69 0a 0a 43 4f 4e 46  mk4tcl".fi..CONF
06d0: 49 47 55 52 45 45 58 54 52 41 3d 22 24 40 22 0a  IGUREEXTRA="$@".
06e0: 65 78 70 6f 72 74 20 43 4f 4e 46 49 47 55 52 45  export CONFIGURE
06f0: 45 58 54 52 41 0a 0a 69 66 20 65 63 68 6f 20 22  EXTRA..if echo "
0700: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
0710: 41 7d 20 22 20 7c 20 67 72 65 70 20 27 20 2d 2d  A} " | grep ' --
0720: 65 6e 61 62 6c 65 2d 74 68 72 65 61 64 73 20 27  enable-threads '
0730: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0740: 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b  ev/null; then..K
0750: 49 54 43 52 45 41 54 4f 52 5f 41 44 44 5f 45 4e  ITCREATOR_ADD_EN
0760: 41 42 4c 45 5f 54 48 52 45 41 44 53 3d 27 31 27  ABLE_THREADS='1'
0770: 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ..KITCREATOR_PKG
0780: 53 3d 22 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f  S="${KITCREATOR_
0790: 50 4b 47 53 7d 20 74 68 72 65 61 64 22 0a 65 6c  PKGS} thread".el
07a0: 69 66 20 65 63 68 6f 20 22 20 24 7b 43 4f 4e 46  if echo " ${CONF
07b0: 49 47 55 52 45 45 58 54 52 41 7d 20 22 20 7c 20  IGUREEXTRA} " | 
07c0: 67 72 65 70 20 27 20 2d 2d 64 69 73 61 62 6c 65  grep ' --disable
07d0: 2d 74 68 72 65 61 64 73 20 27 20 3e 2f 64 65 76  -threads ' >/dev
07e0: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
07f0: 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45 41  l; then..KITCREA
0800: 54 4f 52 5f 41 44 44 5f 45 4e 41 42 4c 45 5f 54  TOR_ADD_ENABLE_T
0810: 48 52 45 41 44 53 3d 27 30 27 0a 66 69 0a 0a 23  HREADS='0'.fi..#
0820: 20 44 65 74 65 72 6d 69 6e 65 20 63 72 6f 73 73   Determine cross
0830: 2d 63 6f 6d 70 69 6c 65 20 73 74 61 74 75 73 0a  -compile status.
0840: 6b 69 74 73 68 5f 64 69 72 3d 22 24 28 63 64 20  kitsh_dir="$(cd 
0850: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f 6b  kitsh/buildsrc/k
0860: 69 74 73 68 2d 2a 20 26 26 20 70 77 64 29 22 20  itsh-* && pwd)" 
0870: 7c 7c 20 65 78 69 74 20 31 0a 68 6f 73 74 5f 6f  || exit 1.host_o
0880: 73 3d 22 24 28 65 63 68 6f 20 22 20 24 7b 43 4f  s="$(echo " ${CO
0890: 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22 20  NFIGUREEXTRA} " 
08a0: 7c 20 73 65 64 20 27 73 40 5e 2e 2a 20 2d 2d 68  | sed 's@^.* --h
08b0: 6f 73 74 3d 5c 28 5b 5e 20 5d 2a 5c 29 20 2e 2a  ost=\([^ ]*\) .*
08c0: 24 40 5c 31 40 0a 74 20 78 0a 64 0a 3a 78 27 29  $@\1@.t x.d.:x')
08d0: 22 0a 62 75 69 6c 64 5f 6f 73 3d 22 24 28 65 63  ".build_os="$(ec
08e0: 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  ho " ${CONFIGURE
08f0: 45 58 54 52 41 7d 20 22 20 7c 20 73 65 64 20 27  EXTRA} " | sed '
0900: 73 40 5e 2e 2a 20 2d 2d 62 75 69 6c 64 3d 5c 28  s@^.* --build=\(
0910: 5b 5e 20 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40 0a  [^ ]*\) .*$@\1@.
0920: 74 20 78 0a 64 0a 3a 78 27 29 22 0a 0a 69 66 20  t x.d.:x')"..if 
0930: 5b 20 2d 7a 20 22 24 7b 62 75 69 6c 64 5f 6f 73  [ -z "${build_os
0940: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 62 75 69 6c  }" ]; then..buil
0950: 64 5f 6f 73 3d 22 24 28 22 24 7b 6b 69 74 73 68  d_os="$("${kitsh
0960: 5f 64 69 72 7d 2f 63 6f 6e 66 69 67 2e 67 75 65  _dir}/config.gue
0970: 73 73 22 29 22 0a 65 6c 73 65 0a 09 62 75 69 6c  ss")".else..buil
0980: 64 5f 6f 73 3d 22 24 28 22 24 7b 6b 69 74 73 68  d_os="$("${kitsh
0990: 5f 64 69 72 7d 2f 63 6f 6e 66 69 67 2e 73 75 62  _dir}/config.sub
09a0: 22 20 22 24 7b 62 75 69 6c 64 5f 6f 73 7d 22 29  " "${build_os}")
09b0: 22 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  ".fi.if [ -z "${
09c0: 68 6f 73 74 5f 6f 73 7d 22 20 5d 3b 20 74 68 65  host_os}" ]; the
09d0: 6e 0a 09 68 6f 73 74 5f 6f 73 3d 22 24 28 22 24  n..host_os="$("$
09e0: 7b 6b 69 74 73 68 5f 64 69 72 7d 2f 63 6f 6e 66  {kitsh_dir}/conf
09f0: 69 67 2e 67 75 65 73 73 22 29 22 0a 65 6c 73 65  ig.guess")".else
0a00: 0a 09 68 6f 73 74 5f 6f 73 3d 22 24 28 22 24 7b  ..host_os="$("${
0a10: 6b 69 74 73 68 5f 64 69 72 7d 2f 63 6f 6e 66 69  kitsh_dir}/confi
0a20: 67 2e 73 75 62 22 20 22 24 7b 68 6f 73 74 5f 6f  g.sub" "${host_o
0a30: 73 7d 22 29 22 0a 66 69 0a 0a 69 66 20 5b 20 22  s}")".fi..if [ "
0a40: 24 7b 68 6f 73 74 5f 6f 73 7d 22 20 21 3d 20 22  ${host_os}" != "
0a50: 24 7b 62 75 69 6c 64 5f 6f 73 7d 22 20 2d 61 20  ${build_os}" -a 
0a60: 2d 6e 20 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 20  -n "${host_os}" 
0a70: 5d 3b 20 74 68 65 6e 0a 09 4b 43 5f 43 52 4f 53  ]; then..KC_CROS
0a80: 53 43 4f 4d 50 49 4c 45 3d 27 31 27 0a 65 6c 73  SCOMPILE='1'.els
0a90: 65 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49  e..KC_CROSSCOMPI
0aa0: 4c 45 3d 27 30 27 0a 66 69 0a 4b 43 5f 43 52 4f  LE='0'.fi.KC_CRO
0ab0: 53 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f  SSCOMPILE_HOST_O
0ac0: 53 3d 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 0a 65  S="${host_os}".e
0ad0: 78 70 6f 72 74 20 4b 43 5f 43 52 4f 53 53 43 4f  xport KC_CROSSCO
0ae0: 4d 50 49 4c 45 20 4b 43 5f 43 52 4f 53 53 43 4f  MPILE KC_CROSSCO
0af0: 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f 53 0a 75 6e  MPILE_HOST_OS.un
0b00: 73 65 74 20 6b 69 74 73 68 5f 64 69 72 0a 0a 23  set kitsh_dir..#
0b10: 20 53 65 74 20 64 65 66 61 75 6c 74 20 74 61 72   Set default tar
0b20: 67 65 74 0a 4b 49 54 54 41 52 47 45 54 3d 22 6b  get.KITTARGET="k
0b30: 69 74 73 68 22 0a 65 78 70 6f 72 74 20 4b 49 54  itsh".export KIT
0b40: 54 41 52 47 45 54 0a 0a 23 20 46 69 78 20 75 70  TARGET..# Fix up
0b50: 20 70 61 63 6b 61 67 65 20 6c 69 73 74 0a 23 23   package list.##
0b60: 20 49 66 20 62 75 69 6c 64 69 6e 67 20 4b 69 74   If building Kit
0b70: 44 4c 4c 2c 20 64 65 66 69 6e 65 20 69 74 20 61  DLL, define it a
0b80: 73 20 6f 75 72 20 74 61 72 67 65 74 0a 69 66 20  s our target.if 
0b90: 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52 45 41  echo " ${KITCREA
0ba0: 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20 67 72  TOR_PKGS} " | gr
0bb0: 65 70 20 27 20 6b 69 74 64 6c 6c 20 27 20 3e 2f  ep ' kitdll ' >/
0bc0: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
0bd0: 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43  null; then..KITC
0be0: 52 45 41 54 4f 52 5f 50 4b 47 53 3d 22 24 28 65  REATOR_PKGS="$(e
0bf0: 63 68 6f 20 22 20 24 7b 4b 49 54 43 52 45 41 54  cho " ${KITCREAT
0c00: 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20 73 65 64  OR_PKGS} " | sed
0c10: 20 27 73 40 20 6b 69 74 64 6c 6c 20 40 20 40 67   's@ kitdll @ @g
0c20: 3b 73 40 5e 20 20 2a 40 40 3b 73 40 20 20 2a 24  ;s@^  *@@;s@  *$
0c30: 40 40 3b 73 40 20 20 20 2a 40 20 40 67 27 29 22  @@;s@   *@ @g')"
0c40: 0a 09 4b 49 54 54 41 52 47 45 54 3d 22 6b 69 74  ..KITTARGET="kit
0c50: 64 6c 6c 22 0a 66 69 0a 0a 23 20 49 66 20 74 68  dll".fi..# If th
0c60: 65 20 75 73 65 72 20 6d 61 6e 75 61 6c 6c 79 20  e user manually 
0c70: 72 65 71 75 65 73 74 65 64 20 22 2d 2d 65 6e 61  requested "--ena
0c80: 62 6c 65 2d 6b 69 74 64 6c 6c 22 2c 20 6d 61 6b  ble-kitdll", mak
0c90: 65 20 69 74 20 73 6f 0a 69 66 20 65 63 68 6f 20  e it so.if echo 
0ca0: 22 78 20 24 40 20 22 20 7c 20 67 72 65 70 20 27  "x $@ " | grep '
0cb0: 20 5b 2d 5d 5b 2d 5d 65 6e 61 62 6c 65 2d 6b 69   [-][-]enable-ki
0cc0: 74 64 6c 6c 20 27 20 3e 2f 64 65 76 2f 6e 75 6c  tdll ' >/dev/nul
0cd0: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74  l 2>/dev/null; t
0ce0: 68 65 6e 0a 09 4b 49 54 54 41 52 47 45 54 3d 22  hen..KITTARGET="
0cf0: 6b 69 74 64 6c 6c 22 0a 66 69 0a 0a 23 23 20 49  kitdll".fi..## I
0d00: 66 20 62 75 69 6c 64 69 6e 67 20 4b 69 74 44 4c  f building KitDL
0d10: 4c 20 61 6e 64 20 54 6b 2c 20 6d 75 73 74 20 64  L and Tk, must d
0d20: 6f 20 54 6b 20 73 74 61 74 69 63 61 6c 6c 79 0a  o Tk statically.
0d30: 23 23 23 20 28 57 65 6c 6c 2c 20 77 65 20 64 6f  ### (Well, we do
0d40: 6e 27 74 20 48 41 56 45 20 74 6f 2c 20 62 75 74  n't HAVE to, but
0d50: 20 69 74 20 77 6f 75 6c 64 20 64 65 66 65 61 74   it would defeat
0d60: 20 6d 75 63 68 20 6f 66 20 74 68 65 20 70 75 72   much of the pur
0d70: 70 6f 73 65 29 0a 69 66 20 5b 20 22 24 7b 4b 49  pose).if [ "${KI
0d80: 54 54 41 52 47 45 54 7d 22 20 3d 20 22 6b 69 74  TTARGET}" = "kit
0d90: 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a 09 69 66  dll" ]; then..if
0da0: 20 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52 45   echo " ${KITCRE
0db0: 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20 67  ATOR_PKGS} " | g
0dc0: 72 65 70 20 27 20 74 6b 20 27 20 3e 2f 64 65 76  rep ' tk ' >/dev
0dd0: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0de0: 6c 3b 20 74 68 65 6e 0a 09 09 69 66 20 5b 20 22  l; then...if [ "
0df0: 24 7b 53 54 41 54 49 43 54 4b 7d 22 20 21 3d 20  ${STATICTK}" != 
0e00: 22 31 22 20 2d 61 20 22 24 7b 53 54 41 54 49 43  "1" -a "${STATIC
0e10: 54 4b 7d 22 20 21 3d 20 22 2d 31 22 20 5d 3b 20  TK}" != "-1" ]; 
0e20: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 27 57 61  then....echo 'Wa
0e30: 72 6e 69 6e 67 3a 20 4c 69 6e 6b 69 6e 67 20 54  rning: Linking T
0e40: 6b 20 73 74 61 74 69 63 61 6c 6c 79 20 62 65 63  k statically bec
0e50: 61 75 73 65 20 79 6f 75 20 61 72 65 20 62 75 69  ause you are bui
0e60: 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 27 20 32 3e  lding KitDLL' 2>
0e70: 26 31 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20  &1....echo '    
0e80: 20 20 20 20 20 53 65 74 20 53 54 41 54 49 43 54       Set STATICT
0e90: 4b 20 74 6f 20 2d 31 20 69 66 20 79 6f 75 20 72  K to -1 if you r
0ea0: 65 61 6c 6c 79 20 77 61 6e 74 20 74 6f 20 6c 69  eally want to li
0eb0: 6e 6b 20 54 6b 20 64 79 6e 61 6d 69 63 61 6c 6c  nk Tk dynamicall
0ec0: 79 2e 27 20 3e 26 32 0a 0a 09 09 09 53 54 41 54  y.' >&2.....STAT
0ed0: 49 43 54 4b 3d 22 31 22 0a 09 09 09 65 78 70 6f  ICTK="1"....expo
0ee0: 72 74 20 53 54 41 54 49 43 54 4b 0a 09 09 66 69  rt STATICTK...fi
0ef0: 0a 09 66 69 0a 0a 09 69 66 20 65 63 68 6f 20 22  ..fi...if echo "
0f00: 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b   ${KITCREATOR_PK
0f10: 47 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6d  GS} " | grep ' m
0f20: 6b 34 74 63 6c 20 27 20 3e 2f 64 65 76 2f 6e 75  k4tcl ' >/dev/nu
0f30: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ll 2>/dev/null; 
0f40: 74 68 65 6e 0a 09 09 69 66 20 5b 20 2d 7a 20 22  then...if [ -z "
0f50: 24 7b 53 54 41 54 49 43 4d 4b 34 7d 22 20 5d 3b  ${STATICMK4}" ];
0f60: 20 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 27 57   then....echo 'W
0f70: 61 72 6e 69 6e 67 3a 20 4c 69 6e 6b 69 6e 67 20  arning: Linking 
0f80: 4d 6b 34 74 63 6c 20 64 79 6e 61 6d 69 63 61 6c  Mk4tcl dynamical
0f90: 6c 79 20 62 65 63 61 75 73 65 20 79 6f 75 20 61  ly because you a
0fa0: 72 65 20 62 75 69 6c 64 69 6e 67 20 4b 69 74 44  re building KitD
0fb0: 4c 4c 27 20 32 3e 26 31 0a 09 09 09 65 63 68 6f  LL' 2>&1....echo
0fc0: 20 27 20 20 20 20 20 20 20 20 20 53 65 74 20 53   '         Set S
0fd0: 54 41 54 49 43 4d 4b 34 20 74 6f 20 6d 61 6b 65  TATICMK4 to make
0fe0: 20 74 68 69 73 20 6d 65 73 73 61 67 65 20 67 6f   this message go
0ff0: 20 61 77 61 79 2e 27 20 3e 26 32 0a 09 09 09 65   away.' >&2....e
1000: 63 68 6f 20 27 20 20 20 20 20 20 20 20 20 53 65  cho '         Se
1010: 74 20 53 54 41 54 49 43 4d 4b 34 20 74 6f 20 31  t STATICMK4 to 1
1020: 20 69 66 20 79 6f 75 20 72 65 61 6c 6c 79 20 77   if you really w
1030: 61 6e 74 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34 74  ant to link Mk4t
1040: 63 6c 20 73 74 61 74 69 63 61 6c 6c 79 20 28 6e  cl statically (n
1050: 6f 72 6d 61 6c 20 64 65 66 61 75 6c 74 29 2e 27  ormal default).'
1060: 20 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20 20   >&2....echo '  
1070: 20 20 20 20 20 20 20 53 65 74 20 53 54 41 54 49         Set STATI
1080: 43 4d 4b 34 20 74 6f 20 30 20 74 6f 20 6c 69 6e  CMK4 to 0 to lin
1090: 6b 20 4d 6b 34 74 63 6c 20 64 79 6e 61 6d 69 63  k Mk4tcl dynamic
10a0: 61 6c 6c 79 20 69 66 20 70 6f 73 73 69 62 6c 65  ally if possible
10b0: 20 28 74 68 69 73 20 69 73 20 77 68 61 74 20 69   (this is what i
10c0: 73 20 68 61 70 70 65 6e 69 6e 67 20 6e 6f 77 29  s happening now)
10d0: 2e 27 20 3e 26 32 0a 09 09 09 65 63 68 6f 20 27  .' >&2....echo '
10e0: 20 20 20 20 20 20 20 20 20 53 65 74 20 53 54 41           Set STA
10f0: 54 49 43 4d 4b 34 20 74 6f 20 2d 31 20 74 6f 20  TICMK4 to -1 to 
1100: 62 75 69 6c 64 20 64 79 6e 61 6d 69 63 61 6c 6c  build dynamicall
1110: 79 2e 27 20 3e 26 32 0a 0a 09 09 09 53 54 41 54  y.' >&2.....STAT
1120: 49 43 4d 4b 34 3d 22 30 22 0a 09 09 09 65 78 70  ICMK4="0"....exp
1130: 6f 72 74 20 53 54 41 54 49 43 4d 4b 34 0a 09 09  ort STATICMK4...
1140: 66 69 0a 09 66 69 0a 66 69 0a 0a 23 20 46 69 6e  fi..fi.fi..# Fin
1150: 64 20 57 69 6e 64 6f 77 73 20 72 65 73 6f 75 72  d Windows resour
1160: 63 65 2d 72 65 6c 61 74 65 64 20 66 69 6c 65 73  ce-related files
1170: 0a 69 66 20 5b 20 2d 66 20 22 6b 69 74 2e 69 63  .if [ -f "kit.ic
1180: 6f 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49 54 43  o" ]; then..KITC
1190: 52 45 41 54 4f 52 5f 49 43 4f 4e 3d 22 24 28 70  REATOR_ICON="$(p
11a0: 77 64 29 2f 6b 69 74 2e 69 63 6f 22 0a 65 6c 73  wd)/kit.ico".els
11b0: 65 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 49 43  e..KITCREATOR_IC
11c0: 4f 4e 3d 22 24 28 65 63 68 6f 20 22 24 28 70 77  ON="$(echo "$(pw
11d0: 64 29 2f 6b 69 74 73 68 2f 62 75 69 6c 64 73 72  d)/kitsh/buildsr
11e0: 63 22 2f 6b 69 74 73 68 2d 2a 2f 74 63 6c 6b 69  c"/kitsh-*/tclki
11f0: 74 2e 69 63 6f 29 22 0a 66 69 0a 69 66 20 5b 20  t.ico)".fi.if [ 
1200: 2d 66 20 22 6b 69 74 2e 72 63 22 20 5d 3b 20 74  -f "kit.rc" ]; t
1210: 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f  hen..KITCREATOR_
1220: 52 43 3d 22 24 28 70 77 64 29 2f 6b 69 74 2e 72  RC="$(pwd)/kit.r
1230: 63 22 0a 65 6c 73 65 0a 09 4b 49 54 43 52 45 41  c".else..KITCREA
1240: 54 4f 52 5f 52 43 3d 22 24 28 65 63 68 6f 20 22  TOR_RC="$(echo "
1250: 24 28 70 77 64 29 2f 6b 69 74 73 68 2f 62 75 69  $(pwd)/kitsh/bui
1260: 6c 64 73 72 63 22 2f 6b 69 74 73 68 2d 2a 2f 6b  ldsrc"/kitsh-*/k
1270: 69 74 2e 72 63 29 22 0a 66 69 0a 65 78 70 6f 72  it.rc)".fi.expor
1280: 74 20 4b 49 54 43 52 45 41 54 4f 52 5f 49 43 4f  t KITCREATOR_ICO
1290: 4e 20 4b 49 54 43 52 45 41 54 4f 52 5f 52 43 0a  N KITCREATOR_RC.
12a0: 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 68 6f 77  .# Determine how
12b0: 20 77 65 20 69 6e 76 6f 6b 65 20 61 20 54 63 6c   we invoke a Tcl
12c0: 20 69 6e 74 65 72 70 72 65 74 65 72 0a 69 66 20   interpreter.if 
12d0: 5b 20 2d 7a 20 22 24 7b 54 43 4c 53 48 5f 4e 41  [ -z "${TCLSH_NA
12e0: 54 49 56 45 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  TIVE}" ]; then..
12f0: 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d 22 66 61  TCLSH_NATIVE="fa
1300: 6c 73 65 22 0a 66 69 0a 66 6f 72 20 74 65 73 74  lse".fi.for test
1310: 73 68 20 69 6e 20 22 24 7b 54 43 4c 53 48 5f 4e  sh in "${TCLSH_N
1320: 41 54 49 56 45 7d 22 20 74 63 6c 73 68 20 74 63  ATIVE}" tclsh tc
1330: 6c 73 68 38 2e 34 20 74 63 6c 73 68 38 2e 35 20  lsh8.4 tclsh8.5 
1340: 74 63 6c 73 68 38 2e 36 20 22 24 7b 54 43 4c 4b  tclsh8.6 "${TCLK
1350: 49 54 3a 2d 74 63 6c 6b 69 74 7d 22 3b 20 64 6f  IT:-tclkit}"; do
1360: 0a 09 69 66 20 65 63 68 6f 20 27 65 78 69 74 20  ..if echo 'exit 
1370: 30 27 20 7c 20 22 24 7b 74 65 73 74 73 68 7d 22  0' | "${testsh}"
1380: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
1390: 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09  ev/null; then...
13a0: 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d 22 24 7b  TCLSH_NATIVE="${
13b0: 74 65 73 74 73 68 7d 22 0a 0a 09 09 62 72 65 61  testsh}"....brea
13c0: 6b 0a 09 66 69 0a 64 6f 6e 65 0a 65 78 70 6f 72  k..fi.done.expor
13d0: 74 20 54 43 4c 53 48 5f 4e 41 54 49 56 45 0a 0a  t TCLSH_NATIVE..
13e0: 23 20 46 75 6e 63 74 69 6f 6e 20 74 6f 20 64 65  # Function to de
13f0: 74 65 72 6d 69 6e 65 20 77 68 61 74 20 62 75 69  termine what bui
1400: 6c 64 20 6d 6f 64 65 20 69 73 20 62 65 69 6e 67  ld mode is being
1410: 20 75 73 65 64 0a 66 75 6e 63 74 69 6f 6e 20 75   used.function u
1420: 73 65 43 6f 6d 6d 6f 6e 42 75 69 6c 64 53 79 73  seCommonBuildSys
1430: 74 65 6d 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 73  tem() {..local s
1440: 63 72 69 70 74 0a 0a 09 73 63 72 69 70 74 3d 22  cript...script="
1450: 24 31 22 0a 0a 09 69 66 20 67 72 65 70 20 2d 69  $1"...if grep -i
1460: 20 27 5e 23 20 2a 42 75 69 6c 64 43 6f 6d 70 61   '^# *BuildCompa
1470: 74 69 62 6c 65 3a 20 2a 4b 69 74 43 72 65 61 74  tible: *KitCreat
1480: 6f 72 20 2a 24 27 20 22 24 7b 73 63 72 69 70 74  or *$' "${script
1490: 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  }" >/dev/null 2>
14a0: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
14b0: 09 09 72 65 74 75 72 6e 20 30 0a 09 66 69 0a 0a  ..return 0..fi..
14c0: 09 72 65 74 75 72 6e 20 31 0a 7d 0a 0a 23 20 43  .return 1.}..# C
14d0: 6c 65 61 6e 75 70 20 62 75 69 6c 64 20 6c 6f 67  leanup build log
14e0: 73 0a 66 6f 72 20 70 6b 67 20 69 6e 20 74 63 6c  s.for pkg in tcl
14f0: 20 74 63 6c 76 66 73 20 7a 6c 69 62 20 24 7b 4b   tclvfs zlib ${K
1500: 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20  ITCREATOR_PKGS} 
1510: 6b 69 74 73 68 3b 20 64 6f 0a 09 72 6d 20 2d 66  kitsh; do..rm -f
1520: 20 22 24 7b 70 6b 67 7d 2f 62 75 69 6c 64 2e 6c   "${pkg}/build.l
1530: 6f 67 22 0a 64 6f 6e 65 0a 0a 23 20 56 65 72 69  og".done..# Veri
1540: 66 79 20 74 68 61 74 20 65 61 63 68 20 63 6f 6d  fy that each com
1550: 70 6f 6e 65 6e 74 20 69 73 20 68 61 70 70 79 20  ponent is happy 
1560: 77 69 74 68 20 74 68 65 20 65 6e 76 69 72 6f 6e  with the environ
1570: 6d 65 6e 74 0a 76 61 6c 69 64 61 74 65 66 61 69  ment.validatefai
1580: 6c 65 64 3d 22 30 22 0a 66 6f 72 20 70 6b 67 20  led="0".for pkg 
1590: 69 6e 20 74 63 6c 20 74 63 6c 76 66 73 20 7a 6c  in tcl tclvfs zl
15a0: 69 62 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f  ib ${KITCREATOR_
15b0: 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20 64 6f 0a  PKGS} kitsh; do.
15c0: 09 66 61 69 6c 65 64 3d 27 30 27 0a 09 69 66 20  .failed='0'..if 
15d0: 5b 20 2d 66 20 22 24 7b 70 6b 67 7d 2f 2e 73 75  [ -f "${pkg}/.su
15e0: 63 63 65 73 73 22 20 5d 3b 20 74 68 65 6e 0a 09  ccess" ]; then..
15f0: 09 63 6f 6e 74 69 6e 75 65 0a 09 66 69 0a 0a 09  .continue..fi...
1600: 69 66 20 5b 20 2d 78 20 22 24 7b 70 6b 67 7d 2f  if [ -x "${pkg}/
1610: 76 61 6c 69 64 61 74 65 2e 73 68 22 20 5d 3b 20  validate.sh" ]; 
1620: 74 68 65 6e 0a 09 09 28 0a 09 09 09 63 64 20 22  then...(....cd "
1630: 24 7b 70 6b 67 7d 22 20 3e 2f 64 65 76 2f 6e 75  ${pkg}" >/dev/nu
1640: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c  ll 2>/dev/null |
1650: 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 2e 2f 76  | exit 1....../v
1660: 61 6c 69 64 61 74 65 2e 73 68 20 33 3e 26 31 20  alidate.sh 3>&1 
1670: 34 3e 26 32 20 3e 3e 20 62 75 69 6c 64 2e 6c 6f  4>&2 >> build.lo
1680: 67 20 32 3e 26 31 20 7c 7c 20 65 78 69 74 20 31  g 2>&1 || exit 1
1690: 0a 09 09 29 20 7c 7c 20 66 61 69 6c 65 64 3d 22  ...) || failed="
16a0: 31 22 0a 0a 09 09 69 66 20 5b 20 22 24 7b 66 61  1"....if [ "${fa
16b0: 69 6c 65 64 7d 22 20 3d 20 27 31 27 20 5d 3b 20  iled}" = '1' ]; 
16c0: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 46 61  then....echo "Fa
16d0: 69 6c 65 64 20 70 72 65 2d 72 65 71 75 69 73 69  iled pre-requisi
16e0: 74 65 20 63 68 65 63 6b 20 66 6f 72 20 24 7b 70  te check for ${p
16f0: 6b 67 7d 22 20 3e 26 32 0a 0a 09 09 09 76 61 6c  kg}" >&2.....val
1700: 69 64 61 74 65 66 61 69 6c 65 64 3d 27 31 27 0a  idatefailed='1'.
1710: 09 09 66 69 0a 09 66 69 0a 64 6f 6e 65 0a 0a 69  ..fi..fi.done..i
1720: 66 20 5b 20 22 24 7b 76 61 6c 69 64 61 74 65 66  f [ "${validatef
1730: 61 69 6c 65 64 7d 22 20 3d 20 27 31 27 20 5d 3b  ailed}" = '1' ];
1740: 20 74 68 65 6e 0a 09 65 78 69 74 20 31 0a 66 69   then..exit 1.fi
1750: 0a 0a 23 20 44 6f 20 62 75 69 6c 64 0a 66 61 69  ..# Do build.fai
1760: 6c 65 64 70 6b 67 73 3d 22 22 0a 62 75 69 6c 64  ledpkgs="".build
1770: 66 61 69 6c 65 64 3d 22 30 22 0a 66 6f 72 20 70  failed="0".for p
1780: 6b 67 20 69 6e 20 74 63 6c 20 74 63 6c 76 66 73  kg in tcl tclvfs
1790: 20 7a 6c 69 62 20 24 7b 4b 49 54 43 52 45 41 54   zlib ${KITCREAT
17a0: 4f 52 5f 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20  OR_PKGS} kitsh; 
17b0: 64 6f 0a 09 66 61 69 6c 65 64 3d 22 30 22 0a 09  do..failed="0"..
17c0: 69 66 20 5b 20 2d 66 20 22 24 7b 70 6b 67 7d 2f  if [ -f "${pkg}/
17d0: 2e 73 75 63 63 65 73 73 22 20 5d 3b 20 74 68 65  .success" ]; the
17e0: 6e 0a 09 09 65 63 68 6f 20 2d 6e 20 22 53 6b 69  n...echo -n "Ski
17f0: 70 70 69 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e  pping ${pkg} ...
1800: 22 0a 09 65 6c 73 65 0a 09 09 65 63 68 6f 20 2d  "..else...echo -
1810: 6e 20 22 42 75 69 6c 64 69 6e 67 20 24 7b 70 6b  n "Building ${pk
1820: 67 7d 20 2e 2e 2e 22 0a 0a 09 09 28 0a 09 09 09  g} ..."....(....
1830: 63 64 20 22 24 7b 70 6b 67 7d 22 20 3e 2f 64 65  cd "${pkg}" >/de
1840: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
1850: 6c 6c 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09  ll || exit 1....
1860: 09 62 75 69 6c 64 5f 73 63 72 69 70 74 3d 27 2e  .build_script='.
1870: 2f 62 75 69 6c 64 2e 73 68 27 0a 09 09 09 69 66  /build.sh'....if
1880: 20 5b 20 2d 78 20 27 6b 69 74 63 72 65 61 74 6f   [ -x 'kitcreato
1890: 72 2d 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74  r-build.sh' ]; t
18a0: 68 65 6e 0a 09 09 09 09 62 75 69 6c 64 5f 73 63  hen.....build_sc
18b0: 72 69 70 74 3d 27 2e 2f 6b 69 74 63 72 65 61 74  ript='./kitcreat
18c0: 6f 72 2d 62 75 69 6c 64 2e 73 68 27 0a 09 09 09  or-build.sh'....
18d0: 66 69 0a 0a 09 09 09 69 66 20 5b 20 2d 66 20 22  fi.....if [ -f "
18e0: 24 7b 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22  ${build_script}"
18f0: 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 62 75 69   ]; then.....bui
1900: 6c 64 5f 73 63 72 69 70 74 73 3d 28 22 24 7b 62  ld_scripts=("${b
1910: 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 29 0a 09  uild_script}")..
1920: 09 09 65 6c 73 65 0a 09 09 09 09 62 75 69 6c 64  ..else.....build
1930: 5f 73 63 72 69 70 74 73 3d 28 24 28 65 63 68 6f  _scripts=($(echo
1940: 20 62 75 69 6c 64 2d 6b 69 74 63 72 65 61 74 6f   build-kitcreato
1950: 72 2d 2a 2e 73 68 29 29 0a 09 09 09 66 69 0a 0a  r-*.sh))....fi..
1960: 09 09 09 63 61 6c 6c 5f 70 6b 67 5f 69 6e 69 74  ...call_pkg_init
1970: 3d 27 31 27 0a 09 09 09 66 6f 72 20 62 75 69 6c  ='1'....for buil
1980: 64 5f 73 63 72 69 70 74 20 69 6e 20 22 24 7b 62  d_script in "${b
1990: 75 69 6c 64 5f 73 63 72 69 70 74 73 5b 40 5d 7d  uild_scripts[@]}
19a0: 22 3b 20 64 6f 0a 09 09 09 09 69 66 20 75 73 65  "; do.....if use
19b0: 43 6f 6d 6d 6f 6e 42 75 69 6c 64 53 79 73 74 65  CommonBuildSyste
19c0: 6d 20 22 24 7b 62 75 69 6c 64 5f 73 63 72 69 70  m "${build_scrip
19d0: 74 7d 22 3b 20 74 68 65 6e 0a 09 09 09 09 09 28  t}"; then......(
19e0: 0a 09 09 09 09 09 09 2e 20 2e 2e 2f 63 6f 6d 6d  ........ ../comm
19f0: 6f 6e 2f 63 6f 6d 6d 6f 6e 2e 73 68 0a 09 09 09  on/common.sh....
1a00: 09 09 09 2e 20 22 24 7b 62 75 69 6c 64 5f 73 63  .... "${build_sc
1a10: 72 69 70 74 7d 22 0a 0a 09 09 09 09 09 09 73 65  ript}"........se
1a20: 74 20 2d 78 0a 0a 09 09 09 09 09 09 69 66 20 5b  t -x........if [
1a30: 20 22 24 7b 63 61 6c 6c 5f 70 6b 67 5f 69 6e 69   "${call_pkg_ini
1a40: 74 7d 22 20 3d 20 27 31 27 20 5d 3b 20 74 68 65  t}" = '1' ]; the
1a50: 6e 0a 09 09 09 09 09 09 09 69 6e 69 74 20 7c 7c  n........init ||
1a60: 20 64 69 65 20 27 69 6e 69 74 20 66 61 69 6c 65   die 'init faile
1a70: 64 27 0a 09 09 09 09 09 09 66 69 0a 0a 09 09 09  d'.......fi.....
1a80: 09 09 09 70 72 65 64 6f 77 6e 6c 6f 61 64 20 7c  ...predownload |
1a90: 7c 20 64 69 65 20 27 70 72 65 64 6f 77 6e 6c 6f  | die 'predownlo
1aa0: 61 64 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09  ad failed'......
1ab0: 09 64 6f 77 6e 6c 6f 61 64 20 7c 7c 20 64 69 65  .download || die
1ac0: 20 27 64 6f 77 6e 6c 6f 61 64 20 66 61 69 6c 65   'download faile
1ad0: 64 27 0a 09 09 09 09 09 09 70 6f 73 74 64 6f 77  d'.......postdow
1ae0: 6e 6c 6f 61 64 20 7c 7c 20 64 69 65 20 27 70 6f  nload || die 'po
1af0: 73 74 64 6f 77 6e 6c 6f 61 64 20 66 61 69 6c 65  stdownload faile
1b00: 64 27 0a 0a 09 09 09 09 09 09 65 78 74 72 61 63  d'........extrac
1b10: 74 20 7c 7c 20 64 69 65 20 27 65 78 74 72 61 63  t || die 'extrac
1b20: 74 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09  t failed'.......
1b30: 09 61 70 70 6c 79 5f 70 61 74 63 68 65 73 20 7c  .apply_patches |
1b40: 7c 20 64 69 65 20 27 61 70 70 6c 79 20 70 61 74  | die 'apply pat
1b50: 63 68 65 73 20 66 61 69 6c 65 64 27 0a 0a 09 09  ches failed'....
1b60: 09 09 09 09 63 64 20 22 24 7b 77 6f 72 6b 64 69  ....cd "${workdi
1b70: 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  r}" || exit 1...
1b80: 09 09 09 09 09 70 72 65 63 6f 6e 66 69 67 75 72  .....preconfigur
1b90: 65 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e  e || die 'precon
1ba0: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 09  figure failed'..
1bb0: 09 09 09 09 09 63 6f 6e 66 69 67 75 72 65 20 7c  .....configure |
1bc0: 7c 20 64 69 65 20 27 63 6f 6e 66 69 67 75 72 65  | die 'configure
1bd0: 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09 09 70   failed'.......p
1be0: 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20  ostconfigure || 
1bf0: 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67 75  die 'postconfigu
1c00: 72 65 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09  re failed'......
1c10: 09 09 70 72 65 62 75 69 6c 64 20 7c 7c 20 64 69  ..prebuild || di
1c20: 65 20 27 70 72 65 62 75 69 6c 64 20 66 61 69 6c  e 'prebuild fail
1c30: 65 64 27 0a 09 09 09 09 09 09 62 75 69 6c 64 20  ed'.......build 
1c40: 7c 7c 20 64 69 65 20 27 62 75 69 6c 64 20 66 61  || die 'build fa
1c50: 69 6c 65 64 27 0a 09 09 09 09 09 09 70 6f 73 74  iled'.......post
1c60: 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f  build || die 'po
1c70: 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a  stbuild failed'.
1c80: 0a 09 09 09 09 09 09 70 72 65 69 6e 73 74 61 6c  .......preinstal
1c90: 6c 20 7c 7c 20 64 69 65 20 27 70 72 65 69 6e 73  l || die 'preins
1ca0: 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 09 09 09  tall failed'....
1cb0: 09 09 09 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  ...install || di
1cc0: 65 20 27 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65  e 'install faile
1cd0: 64 27 0a 09 09 09 09 09 09 70 6f 73 74 69 6e 73  d'.......postins
1ce0: 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73  tall || die 'pos
1cf0: 74 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27  tinstall failed'
1d00: 0a 0a 09 09 09 09 09 09 63 72 65 61 74 65 72 75  ........createru
1d10: 6e 74 69 6d 65 20 7c 7c 20 64 69 65 20 27 63 72  ntime || die 'cr
1d20: 65 61 74 65 72 75 6e 74 69 6d 65 20 66 61 69 6c  eateruntime fail
1d30: 65 64 27 0a 0a 09 09 09 09 09 09 73 65 74 20 2b  ed'........set +
1d40: 78 0a 09 09 09 09 09 29 20 33 3e 26 31 20 34 3e  x......) 3>&1 4>
1d50: 26 32 20 3e 3e 20 62 75 69 6c 64 2e 6c 6f 67 20  &2 >> build.log 
1d60: 32 3e 26 31 20 7c 7c 20 65 78 69 74 20 31 0a 09  2>&1 || exit 1..
1d70: 09 09 09 65 6c 73 65 0a 09 09 09 09 09 22 24 7b  ...else......"${
1d80: 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 20 33  build_script}" 3
1d90: 3e 26 31 20 34 3e 26 32 20 3e 3e 20 62 75 69 6c  >&1 4>&2 >> buil
1da0: 64 2e 6c 6f 67 20 32 3e 26 31 20 7c 7c 20 65 78  d.log 2>&1 || ex
1db0: 69 74 20 31 0a 09 09 09 09 66 69 0a 0a 09 09 09  it 1.....fi.....
1dc0: 09 63 61 6c 6c 5f 70 6b 67 5f 69 6e 69 74 3d 27  .call_pkg_init='
1dd0: 30 27 0a 09 09 09 64 6f 6e 65 0a 09 09 29 20 7c  0'....done...) |
1de0: 7c 20 66 61 69 6c 65 64 3d 22 31 22 0a 09 66 69  | failed="1"..fi
1df0: 0a 0a 09 69 66 20 5b 20 22 24 7b 66 61 69 6c 65  ...if [ "${faile
1e00: 64 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65  d}" = "1" ]; the
1e10: 6e 0a 09 09 65 63 68 6f 20 22 20 66 61 69 6c 65  n...echo " faile
1e20: 64 2e 22 0a 09 09 66 61 69 6c 65 64 70 6b 67 73  d."...failedpkgs
1e30: 3d 22 24 7b 66 61 69 6c 65 64 70 6b 67 73 7d 20  ="${failedpkgs} 
1e40: 24 7b 70 6b 67 7d 22 0a 09 65 6c 73 65 0a 09 09  ${pkg}"..else...
1e50: 65 63 68 6f 20 22 20 64 6f 6e 65 2e 22 0a 09 66  echo " done."..f
1e60: 69 0a 0a 09 63 61 73 65 20 22 24 7b 70 6b 67 7d  i...case "${pkg}
1e70: 22 20 69 6e 0a 09 09 74 63 6c 29 0a 09 09 09 54  " in...tcl)....T
1e80: 43 4c 43 4f 4e 46 49 47 44 49 52 3d 24 28 66 69  CLCONFIGDIR=$(fi
1e90: 6e 64 20 22 24 28 70 77 64 29 2f 74 63 6c 2f 62  nd "$(pwd)/tcl/b
1ea0: 75 69 6c 64 22 20 2d 6e 61 6d 65 20 74 63 6c 43  uild" -name tclC
1eb0: 6f 6e 66 69 67 2e 73 68 20 7c 20 68 65 61 64 20  onfig.sh | head 
1ec0: 2d 31 20 7c 20 73 65 64 20 27 73 40 2f 5b 5e 2f  -1 | sed 's@/[^/
1ed0: 5d 2a 24 40 40 27 29 0a 09 09 09 54 43 4c 43 4f  ]*$@@')....TCLCO
1ee0: 4e 46 49 47 44 49 52 54 41 49 4c 3d 22 24 28 62  NFIGDIRTAIL="$(b
1ef0: 61 73 65 6e 61 6d 65 20 22 24 7b 54 43 4c 43 4f  asename "${TCLCO
1f00: 4e 46 49 47 44 49 52 7d 22 29 22 0a 09 09 09 65  NFIGDIR}")"....e
1f10: 78 70 6f 72 74 20 54 43 4c 43 4f 4e 46 49 47 44  xport TCLCONFIGD
1f20: 49 52 20 54 43 4c 43 4f 4e 46 49 47 44 49 52 54  IR TCLCONFIGDIRT
1f30: 41 49 4c 0a 0a 09 09 09 23 20 49 66 20 54 63 6c  AIL.....# If Tcl
1f40: 20 77 61 73 20 63 6f 6d 70 69 6c 65 64 20 77 69   was compiled wi
1f50: 74 68 20 74 68 72 65 61 64 73 20 65 6e 61 62 6c  th threads enabl
1f60: 65 64 20 70 61 73 73 20 2d 2d 65 6e 61 62 6c 65  ed pass --enable
1f70: 2d 74 68 72 65 61 64 73 20 74 6f 20 61 6c 6c 20  -threads to all 
1f80: 73 75 62 2d 70 72 6f 6a 65 63 74 73 0a 09 09 09  sub-projects....
1f90: 69 66 20 5b 20 22 24 7b 4b 49 54 43 52 45 41 54  if [ "${KITCREAT
1fa0: 4f 52 5f 41 44 44 5f 45 4e 41 42 4c 45 5f 54 48  OR_ADD_ENABLE_TH
1fb0: 52 45 41 44 53 3a 2d 31 7d 22 20 21 3d 20 27 30  READS:-1}" != '0
1fc0: 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 69 66  ' ]; then.....if
1fd0: 20 5b 20 22 24 28 20 2e 20 22 24 7b 54 43 4c 43   [ "$( . "${TCLC
1fe0: 4f 4e 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e  ONFIGDIR}/tclCon
1ff0: 66 69 67 2e 73 68 22 20 26 26 20 65 63 68 6f 20  fig.sh" && echo 
2000: 22 24 7b 54 43 4c 5f 54 48 52 45 41 44 53 3a 2d  "${TCL_THREADS:-
2010: 30 7d 22 20 29 22 20 3d 20 27 31 27 20 5d 3b 20  0}" )" = '1' ]; 
2020: 74 68 65 6e 0a 09 09 09 09 09 43 4f 4e 46 49 47  then......CONFIG
2030: 55 52 45 45 58 54 52 41 3d 22 24 7b 43 4f 4e 46  UREEXTRA="${CONF
2040: 49 47 55 52 45 45 58 54 52 41 7d 20 2d 2d 65 6e  IGUREEXTRA} --en
2050: 61 62 6c 65 2d 74 68 72 65 61 64 73 22 0a 09 09  able-threads"...
2060: 09 09 66 69 0a 09 09 09 66 69 0a 09 09 09 3b 3b  ..fi....fi....;;
2070: 0a 09 65 73 61 63 0a 0a 09 69 66 20 5b 20 22 24  ..esac...if [ "$
2080: 7b 66 61 69 6c 65 64 7d 22 20 3d 20 22 31 22 20  {failed}" = "1" 
2090: 5d 3b 20 74 68 65 6e 0a 09 09 62 75 69 6c 64 66  ]; then...buildf
20a0: 61 69 6c 65 64 3d 22 31 22 0a 09 65 6c 73 65 0a  ailed="1"..else.
20b0: 09 09 74 6f 75 63 68 20 22 24 7b 70 6b 67 7d 2f  ..touch "${pkg}/
20c0: 2e 73 75 63 63 65 73 73 22 0a 09 66 69 0a 64 6f  .success"..fi.do
20d0: 6e 65 0a 0a 69 66 20 5b 20 2d 6e 20 22 24 7b 66  ne..if [ -n "${f
20e0: 61 69 6c 65 64 70 6b 67 73 7d 22 20 5d 3b 20 74  ailedpkgs}" ]; t
20f0: 68 65 6e 0a 09 65 63 68 6f 20 22 46 61 69 6c 65  hen..echo "Faile
2100: 64 20 74 6f 20 62 75 69 6c 64 3a 24 7b 66 61 69  d to build:${fai
2110: 6c 65 64 70 6b 67 73 7d 22 0a 66 69 0a 0a 69 66  ledpkgs}".fi..if
2120: 20 5b 20 22 24 7b 62 75 69 6c 64 66 61 69 6c 65   [ "${buildfaile
2130: 64 7d 22 20 21 3d 20 22 30 22 20 5d 3b 20 74 68  d}" != "0" ]; th
2140: 65 6e 0a 09 65 63 68 6f 20 27 57 41 52 4e 49 4e  en..echo 'WARNIN
2150: 47 3a 20 42 75 69 6c 64 20 69 73 20 6c 69 6b 65  G: Build is like
2160: 6c 79 20 69 6e 63 6f 6d 70 6c 65 74 65 20 6f 72  ly incomplete or
2170: 20 66 61 69 6c 65 64 2e 27 20 3e 26 32 0a 66 69   failed.' >&2.fi
2180: 0a 0a 63 70 20 27 6b 69 74 73 68 2f 62 75 69 6c  ..cp 'kitsh/buil
2190: 64 27 2f 6b 69 74 73 68 2d 2a 2f 6c 69 62 74 63  d'/kitsh-*/libtc
21a0: 6c 6b 69 74 2a 20 2e 20 3e 2f 64 65 76 2f 6e 75  lkit* . >/dev/nu
21b0: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 63  ll 2>/dev/null.c
21c0: 70 20 27 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f  p 'kitsh/build'/
21d0: 6b 69 74 73 68 2d 2a 2f 6b 69 74 20 22 74 63 6c  kitsh-*/kit "tcl
21e0: 6b 69 74 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20  kit-${TCLVERS}" 
21f0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
2200: 76 2f 6e 75 6c 6c 0a 69 66 20 5b 20 21 20 2d 66  v/null.if [ ! -f
2210: 20 22 74 63 6c 6b 69 74 2d 24 7b 54 43 4c 56 45   "tclkit-${TCLVE
2220: 52 53 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 63 70  RS}" ]; then..cp
2230: 20 27 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f 6b   'kitsh/build'/k
2240: 69 74 73 68 2d 2a 2f 6b 69 74 2e 65 78 65 20 22  itsh-*/kit.exe "
2250: 74 63 6c 6b 69 74 2d 24 7b 54 43 4c 56 45 52 53  tclkit-${TCLVERS
2260: 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  }" >/dev/null 2>
2270: 2f 64 65 76 2f 6e 75 6c 6c 0a 66 69 0a 0a 66 6f  /dev/null.fi..fo
2280: 72 20 70 6f 73 74 73 63 72 69 70 74 20 69 6e 20  r postscript in 
2290: 63 6f 6d 6d 6f 6e 2f 70 6f 73 74 2f 2a 3b 20 64  common/post/*; d
22a0: 6f 0a 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b  o..if [ ! -f "${
22b0: 70 6f 73 74 73 63 72 69 70 74 7d 22 20 5d 3b 20  postscript}" ]; 
22c0: 74 68 65 6e 0a 09 09 63 6f 6e 74 69 6e 75 65 0a  then...continue.
22d0: 09 66 69 0a 0a 09 22 24 7b 70 6f 73 74 73 63 72  .fi..."${postscr
22e0: 69 70 74 7d 22 0a 64 6f 6e 65 0a 0a 65 78 69 74  ipt}".done..exit
22f0: 20 22 24 7b 62 75 69 6c 64 66 61 69 6c 65 64 7d   "${buildfailed}
2300: 22 0a                                            ".